/*********** FDTDp֐Qt@C *******************/
/*													*/
/*		Initialize()	ϐ̏			*/
/*		Make_param()	vZpϐ̌vZ		*/
/*		Driver()	U֐			*/
/*		WaveT()		gg`f[^̕ۑ		*/
/*		OutputF()	vZỈz		*/
/*		Initialize()	ϐ̏			*/
/*      	OutputW()       gg`̏o			*/
/*		FieldSnap()	uz̏o		*/
/*								*/
/****************************************************/

/****************************************************/
void	Initialize( void )
{
	for( i = 0 ; i <= x_max - 1 ; ++i)	{
		for( j = 0 ; j <= y_max - 1 ; ++j)	{
				P1[i][j] = 0;
				Vx[i][j] = 0;
				Vy[i][j] = 0;
		}
	}

}

/****************************************************/
void	Make_param(void)
{

	int snap;
	
/*p[^̓*/

	range = 1200;	/*` [m]*/
	depth = 1200;	/*[x [m]*/
	cal_time = 1.2;	/*`[sec]*/

	dx = 3.0;				/*ԗ̈悫ݕ[m]*/
	dt = 0.0006;			/*ԗ̈悫ݕ[sec]*/

	f = 25;					/*Ug*/
	WN = 4;					/*UpXigj*/
	SC = 2;					/*U֐*/
	/*SC = 0:Ag, 1:KEVpXg, 2:njNpXg*/

	rou0 = 1000;			/*x*/
	c0 = 1500;				/**/
	absp0 = 0.0;			/*zW[dB/]*/
	gensui0 = (f*absp0)/(8.686*c0);	/*W0( neper/m ) */


	BC = 0;					/*zE*/
	/*BC = 0:Mur 1, 1:Mur 2, 2:Higdon 1, 3:Higdon 2,*/

/*ep[^̎Zo*/
	x_max = (int)(range/dx);
	y_max = (int)(depth/dx);
	T_max = (int)(cal_time/dt);


	SX = (int)(x_max/2);	/*g_iX)*/
	SY = (int)(y_max/2);	/*g_iY)*/

	RX = (int)(4*x_max/5);	/*g_iX)*/
	RY = (int)(y_max/4);	/*g_iY)*/


	snap = 10;				/*ut@C(Snapshot)̏o͖*/
	del_T = (int)(T_max/snap);

	if(SC== 0) 
	{
	W_end = T_max;	/*UIݐ̂Q{*/
	}
	else if (SC == 1){
	W_end = (int)( 2* WN  / ( f * dt ) );
	}
	else if (SC == 2){
	W_end = (int)( WN  / ( f * dt ) );	/*UIݐ̂Q{*/
	}

/*	t@CԈ*/
    mg = 0;	
    ng = 0;

/*܂񂾔gCČWi alpha1 ̎Zoj*/

	hasu_o0 = 2*PI*f/c0;			/*ۂ̔g */
	hasu0 = sqrt( hasu_o0*hasu_o0 - gensui0*gensui0 );/*̂ꍇ̔g*/
	c_m0 = 2*PI*f/hasu0;		/*̂ꍇ̉*/
	alpha0 = 2*hasu_o0*gensui0*rou0*c_m0/hasu0; /*z*/


/*̌W̎Zo*/

	kap0 = c_m0 * c_m0 * rou0;
	Cp1 = 1.0;
	Cp2 = kap0 * dt / dx;
	Cv1 = ( 2*rou0 - alpha0*dt )/( 2*rou0 + alpha0*dt );
	Cv2 = dt*2 / (( 2*rou0 + alpha0*dt )* dx );

/*zEpW̎Zo*/

	/*Higdon Coefficents*/
	a1 = 1/cos(0.0);
	a2 = 1/cos(0.0);
	d1 = 0.005;
	d2 = 0.005;

	Ca0 = ( c_m0 * dt - dx) / ( c_m0 * dt + dx );
	Ca1 = ( dx*2 ) / ( c_m0 * dt + dx );
	Ca2 = ( dx * c_m0 * dt * c_m0 * dt) / (dx * dx * 2 *( c_m0 * dt + dx ));

	Cah1 = ( a1*c_m0 * dt - dx) / ( a1*c_m0 * dt + dx );
	Cah2 = ( a2*c_m0 * dt - dx) / ( a2*c_m0 * dt + dx );

}



/************* U ****************************/


/*pXg*/

double	Driver( int T )
{
    double	so, w, Tr, tau, al;
	w = 2 * PI * f;
	Tr = w * dt * (double)T	/ WN;

    switch(SC)
{
	case 0: /*Ag*/

	if( Tr <= PI )	{
	so = (( 1 - cos( (double)(w * dt * (double)T / WN )) ) * sin( (double)(w * dt * (double)T ))/2);
	}	else	{
		so = sin( (double)(w * dt * (double)T ));
	}
	break;

	case 1: /*pXgiKEVj*/
	
	tau = (double)WN/f;
	al = (4/tau)*(4/tau);
	so = exp(-al*(dt*(double)T-tau)*(dt*(double)T-tau))*sin(w*(dt*(double)T-tau));
	break;

	case 2: /*pXginjOj*/

	if( T <= W_end )	{		
	so = (double)(( 1 - cos( (double)(w * dt * (double)T / WN )) ) * sin( (double)(w * dt * (double)T ))/2);
	}	else	{
	so = 0.0;
	}
	break;

	case 3: /*j*/


	break;

	default: /*pXgiKEVj*/
	tau = (double)WN/f;
	al = (4/tau)*(4/tau);
	so = exp(-al*(dt*(double)T-tau)*(dt*(double)T-tau))*sin(w*(dt*(double)T-tau));


	}

	return	so;
}


/************* gg`f[^ۑ ****************************/

void	WaveT( void )
{
	amp1[T]= P1[SX][SY];
	amp2[T]= P1[RX][RY];
}

/****************************************************/
void	OutputF(void)
{
	char	file11[50] = "field.txt";
	FILE	*fp11;
	double bun;

	if( NULL == ( fp11 = fopen( file11,"w" ) ) )
	{
		printf("\n\n Cannot Open File : %s\n",file11);
		exit(1);
	}

	for( j = 0 ; j <= y_max - 1 ; j++)	{
		for( i = 0 ; i <= x_max - 1 ; i++)	{
			bun = P1[i][j]*P1[i][j];
		if( bun < 1e-15)
			{
				bun = -150;
			}	else	{
				bun =  10.0*log10( bun );
			}
			fprintf(fp11,"%f\t",(float)bun);

/*			fprintf(fp11,"%f\t",(float)P1[i][j]);*/
			i=i+mg;
		}
		fprintf(fp11,"\n");
		j=j+ng;
	}
	fclose(fp11);

		printf("output sound pressure field file : %s\n",file11);

}

void	OutputW(void)
{
	char	file12[50] = "t_wave.txt";
	char	file13[50] = "r_wave.txt";
	FILE	*fp12,*fp13;
	double sub_t;
	double bun1,bun2;

	if( NULL == ( fp12 = fopen( file12,"w" ) ) )
	{
		printf("\n\n Cannot Open File : %s\n",file12);
		exit(1);
	}

	if( NULL == ( fp13 = fopen( file13,"w" ) ) )
	{
		printf("\n\n Cannot Open File : %s\n",file13);
		exit(1);
	}

	for( i = 0 ; i <= T_max ; i++ )
			{
				bun1 = amp1[i];
				bun2 = amp2[i];

				sub_t = dt*(double)i;
				fprintf(fp12,"%e\t%e\n",sub_t,bun1);
				fprintf(fp13,"%e\t%e\n",sub_t,bun2);
			}
		fclose(fp12);
		fclose(fp13);

		printf("output projected wave file : %s\n",file12);
		printf("output received wave file : %s\n",file13);

}


/****************************************************/
void	FieldSnap(void)
{
	FILE	*fp[500];	 
	char	fname[7];
	int		k,l,m,n;
	static	char	number[11]="0123456789";
	double	bun;


		k = T/del_T;
		l = (int)k/100;
		m = (int)(k%100-k%10)/10;
		n = k%10;

		fname[0] = number[l];
		fname[1] = number[m];
		fname[2] = number[n];
		fname[3] = '.';
		fname[4] = 't';
		fname[5] = 'x';
		fname[6] = 't';
		fname[7] = 0;

		if( NULL == ( fp[k] = fopen( fname,"w" ) ) )
		{
			printf("\n\n Cannot Open File : %s\n",fname);
			exit(1);
		}

		for( j = 0 ; j <=  y_max - 1 ; j++)	
		{
			for( i = 0 ; i <= x_max - 1 ; i++)	
			{
				bun = P1[i][j]*P1[i][j] ;
			if( bun < 1e-15)	{
				bun = (float)-150;
			}	else	{
				bun = (float)( 10.0*log10( bun ));
			}

				fprintf(fp[k],"%f\t",(float)bun);
				i = i + mg;
			}
			fprintf(fp[k],"\n");
			j = j + ng ;
		}
		fclose(fp[k]);	 

/*		printf("\n output snapshot file : %s\n\n",fname);
*/		

}

